/*
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Copyright (c) 2012 digitalSTROM.org, Zurich, Switzerland
 *  Author: Roman Khler <roman.koehler@aizo.com>
 */


var fLoading=false;
var oTimedEvent;

function getParameterByName(name)
{
  name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
  var regexS = "[\\?&]" + name + "=([^&#]*)";
  var regex = new RegExp(regexS);
  var results = regex.exec(window.location.search);
  if(results == null)
    return "";
  else
    return decodeURIComponent(results[1].replace(/\+/g, " "));
}


function changeListener() {
    var sValue=dss.ajaxSyncRequest('/json/property/getString',{path:'/usr/states/holiday/value'});
    var oValue=JSON.parse(sValue);
    if (oValue!=null)
        if (oValue.result!=null)
            if (oValue.result.value!=null) {
                if (oValue.result.value=='on')
                    return _("Simulation is <b>active</b>") + "<br><br>";
                else
                    return _("Simulation is <b>not active</b>") + "<br><br>";
            }
    return "Simulationstate is currently not known, please wait" + "<br><br>";
}

function modeChange(newValue) {
    if (fLoading)
        return;
    dss.raiseEvent('system-addon-presence-simulator', {
        actions : 'setMode',
        value : newValue
    });
}

function emailChange(fEnabled,txtReceiver) {
    if (fLoading)
        return;
    dss.raiseEvent('system-addon-presence-simulator', {
        actions : 'setEmail',
        enabled : (fEnabled?1:0),
        receiver : txtReceiver
    });
}

Ext.define(
                'DSS.addon.PresenceSimulator',
                {

                    extend : 'DSS.addon.Framework',
                    fExpertMode:false,
                    config : {
                        appName : 'Presence Simulator',
                        appId : 'presence-simulator',
                        appVersion : '1.3.25',
                        appIcon : 'images/app_icon.png'
                    },

                    getHelp : function() {
                        return Ext.create('Ext.Component', {
                            whiteSpace : 'normal',
                            padding : '0 20 0 0', //top right bottom left
                            loader : {
                                url : 'locale/' + dss.staticDataModel.activeLanguage + '/help.html',
                                autoLoad : true,
                                disableCaching : false
                            }
                        });
                    },
                    makeAutoModePanel : function () {
                        this.autoMode=Ext.create('Ext.form.RadioGroup',{
                            fieldLabel:_('When should the simulation be active?'),
                            labelSeparator : '',
                            items:[
                                   {   inputValue:0,
                                       boxLabel:_('always off - holiday times and absent state will not be used'),
                                       name:'autoMode'},
                                   {   inputValue:1,
                                       boxLabel:_('only on holidays'),
                                       name:'autoMode'},
                                   {   inputValue:2,
                                       boxLabel:_('on holidays and when absend'),
                                       name:'autoMode'},
                                   {   inputValue:3,
                                       boxLabel:_('always on'),
                                       name:'autoMode'}
                                   ],
                            columns:1,
                            labelAlign:'top',
                            style: {color:"#005138"}
                        });
                        this.autoMode.addListener('change',function(oThis,newValue,oldValue,eOpts) {
                            if (typeof(newValue.autoMode)=='number')
                                modeChange(newValue.autoMode);   
                        });
                        return this.autoMode;
                    },
                    makeStatePanel : function () {
                        var oReturn = Ext.create('Ext.form.Panel', {
                            border : 0,
                            html:'<div id="subPanel_AutoQuery" style="color:#005138;">' + changeListener() + '</div>',
                            style: {color:"#005138"}
                        });
                        
                        var oFunct=function()
                        {                       
                            if (document.getElementById("subPanel_AutoQuery")!=null){                 
                                document.getElementById("subPanel_AutoQuery").innerHTML=changeListener();
                            }
                        };                        
                        window.setInterval(oFunct,5*1000);
                        return oReturn;
                    },
                    makeEmailPanel : function () {
                        var me=this;
                        var description = Ext.create('Ext.form.Panel', {
                            border : 0,
                            html:'<span style="color:#005138;">' + _('Should be send a Email on turning on or off the simulation ?')+ '</span>',
                            padding: "0 0 5 0", 
                            style: {color:"#005138"},
                            colspan:3
                        });
                        
                        var oNo= Ext.create('Ext.form.field.Radio',{
                            name : 'edit_emailReceiver_email_enabler',
                            inputValue : 0,
                            boxLabel: _('no'),
                            colspan:3,
                            style: {color:"#005138"}
                        });
                        this.emailEnabler= Ext.create('Ext.form.field.Radio',{
                            name : 'edit_emailReceiver_email_enabler',
                            inputValue : 1,
                            boxLabel: _('yes'),
                            width:100,
                            style: {color:"#005138"}    
                        });
                        
                        
                        this.emailAdress = Ext.create('Ext.form.field.Text', {
                            name : 'edit_emailReceiver_email_email',
                            id : 'edit_emailReceiver_email_email',
                            fieldLabel : _('Receiver'),
                            allowBlank : false,
                            blankText : _('Receiver must be provided'),
                            invalidText : _('Receiver must be provided'),
                            regex : /\b[A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i,
                            regexText : _('The emailadress has the wrong format'),
                            style: {color:"#005138"},
                            width:400,
                            labelWidth:65
                        });
                            
                        var yesPanel = Ext.create('Ext.Panel', {
                            border : 0,
                            width : 600,
                            layout: {
                                type: 'hbox',
                                align: 'center'
                            },
                            items:[this.emailEnabler,this.emailAdress ]
                        });

                        var oButton=Ext.create('Ext.button.Button',{
                            text:_('apply'),
                            handler:function() {emailChange(me.emailEnabler.getValue(),me.emailAdress.getValue());}
                        });
                        yesPanel.add(oButton);                  

                        this.emailEnabler.addListener('change',function(oThis,newValue,oldValue,eOpts) {
                            if (newValue) {
                                oButton.enable();
                                me.emailAdress.enable();
                            } else {
                                oButton.disable();
                                me.emailAdress.disable();
                            } 
                            emailChange(me.emailEnabler.getValue(),me.emailAdress.getValue());
                        });
                        oNo.addListener('change',function(oThis,newValue,oldValue,eOpts) {
                            if (!newValue) {
                                oButton.enable();
                                me.emailAdress.enable();
                            } else {
                                oButton.disable();
                                me.emailAdress.disable();
                            }                                
                        });
                                                                
                        return Ext.create('Ext.Panel', {
                            layout: {
                                type: 'vbox'
                            },
                            border : 0,
                            height: 70,
                            width: 700,
                            items:[description,
                                   oNo,
                                   yesPanel]
                        });
                        
                    },
                    autoMode:null,
                    emailEnabler:null,
                    emailAdress:null,
                    getContent : function() {

                        var me = this;

                        var oConfigHoliday = {
                            defaultSortCol : 'name',
                            border: false,
                            storeConfig : {
                                storeId : 'holidayStore',
                                fields : [ {
                                    name : 'id'
                                }, {
                                    name : 'name',
                                    sortType : 'asUCText'
                                }, {
                                    name : 'von',
                                    sortType : 'asUCText'
                                }, {
                                    name : 'bis',
                                    sortType : 'asUCText'
                                } ]
                            },
                            columns : [ {
                                header : _('Name'),
                                dataIndex : 'name',
                                xtype : 'textcolumn',
                                flex : 1
                            }, {
                                header : _('from'),
                                dataIndex : 'von',
                                xtype : 'datecolumn',
                                width : 200
                            }, {
                                header : _('until'),
                                dataIndex : 'bis',
                                xtype : 'datecolumn',
                                width : 200
                            } ],
                            buttonText : {
                                newButton : _('New holiday'),
                                editButton : _('Edit holiday'),
                                deleteButton : _('Delete holiday')
                            },
                            editorConfig : {
                                title : _('edit holiday'),
                                staticControls : [ {
                                    type : 'text',
                                    label : _('Name'),
                                    id : 'name'
                                }, {
                                    type : 'hidden',
                                    label : 'id',
                                    id : 'id'
                                }, {
                                    type : 'date',
                                    label : _('from'),
                                    id : 'von'
                                }, {
                                    type : 'date',
                                    label : _('until'),
                                    id : 'bis'
                                } ]
                            },
                            listeners : {
                                'loadDataStore' : function(grid) {
                                    me.loadHolidayParameter(grid);
                                },
                                'saveEntry' : function(grid, values) {
                                    dss.raiseEvent('system-addon-presence-simulator.holiday-config', {
                                        actions : 'save',
                                        value : Ext.JSON.encode(values)
                                    });
                                    me.waitAndReloadHoliday(grid);
                                },
                                'deleteEntry' : function(grid, entry) {
                                    dss.raiseEvent('system-addon-presence-simulator.holiday-config', {
                                        actions : 'delete',
                                        id : entry.get('id')
                                    });
                                    me.waitAndReloadHoliday(grid);
                                }
                            }
                        };
                        var oConfigActivity = {
                            defaultSortCol : 'name',
                            disabledProperty : 'disabled',
                            border: false,
                            multiselect:true,
                            storeConfig : {
                                storeId : 'actionStore',
                                fields : [ {
                                    name : 'id'
                                }, {
                                    name : 'disabled',
                                    sortType : 'asBoolean'
                                }, {
                                    name : 'name',
                                    sortType : 'asUCText'
                                }, {
                                    name : 'actions',
                                    sortType : 'asAction'
                                }, {
                                    name : 'time',
                                    sortType : 'asTime'
                                },{name: 'conditions',  sortType: 'asCondition' },
                                {name: 'grouping',  sortType: 'asUCText' },
                                 {
                                    name : 'recurrence',
                                    sortType : 'asRecurrence'
                                } ]
                            },
                            columns : [ {
                                header : _('Active'),
                                dataIndex : 'disabled',
                                resizable : false,
                                xtype : 'disabledcolumn',
                                width : 50
                            }, {
                                header : _('Name'),
                                dataIndex : 'name',
                                xtype : 'textcolumn',
                                width : 200
                            }, {
                                header : _('Action'),
                                dataIndex : 'actions',
                                maintainFlex : true,
                                flex : 5,
                                xtype : 'actioncolumn'
                            }, {
                                header : _('Time'),
                                dataIndex : 'time',
                                xtype : 'timecolumn',
                                width : 200,
                                customColumnRenderer : function (val, metadata, record, rowIdx, colIdx, store, view) {
                                    var fOverride=false;
                                    var pad = function(i) { return (i < 10 ? '0'+i : i); };

                                    var sText=  pad(Math.floor(Math.abs(val.offset/3600))) + ":" +
                                    pad(Math.floor(Math.abs(val.offset/60)%60));

                                    switch (val.timeBase)
                                    {
                                        case 'beforeHoliday':
                                            fOverride=true;
                                            if (val.offset==0)
                                                sText = _('at simulation start');
                                            else if (val.offset<0)
                                                sText = Ext.String.format2(_("{time} before simulation starts"),{time:sText});
                                            else
                                                sText = Ext.String.format2(_("{time} after simulation starts"),{time:sText});
                                        break;
                                        case 'afterHoliday':
                                            fOverride=true;
                                            if (val.offset==0)
                                                sText = _('at simulation end');
                                            else if (val.offset<0)
                                                sText = Ext.String.format2(_("{time} before simulation ends"),{time:sText});
                                            else
                                                sText = Ext.String.format2(_("{time} after simulation ends"),{time:sText});
                                        break;
                                    }
                                    if (!fOverride)
                                        return null;
                                    if (val.limitBefore!=null)  {
                                        sText+=Ext.String.format2(_("<br>but not past {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(val.limitBefore/3600))),minute:pad(Math.floor(Math.abs(val.limitBefore/60)%60))});
                                    }
                                    if (val.limitAfter!=null)  {
                                        sText+=Ext.String.format2(_("<br>but not before {hour}:{minute} o'clock"),{hour:pad(Math.floor(Math.abs(val.limitAfter/3600))),minute:pad(Math.floor(Math.abs(val.limitAfter/60)%60))});
                                    }
                                    if (val.random!=null) {
                                        sText="&plusmn;" + sText;
                                    } 
                                        
                                    return sText;
                                }                               
                            }, {
                                header : _('Recurrence'),
                                dataIndex : 'recurrence',
                                xtype : 'recurrencecolumn',
                                width : 160
                            } ,{
                                header: _('Conditions'),
                                dataIndex: 'conditions', // alibi index
                                xtype: 'conditioncolumn',
                                maintainFlex: true,
                                flex: 3,
                                customRendererOptions:{hideEnabled:true,hideWeekdays:false,hideGenericSystemStates:false,hideZoneStates:false,hideTimeframe:false,filterSystemState:[],
                                	stateTitles:[{name:'daylight',value:true,title:_('grid_daylight_true')},{name:'daylight',value:false,title:_('grid_daylight_false')},
                                	             {name:'daynight',value:true,title:_('grid_daynight_true')},{name:'daynight',value:false,title:_('grid_daynight_false')},
                                	             {name:'panic',value:'1',title:_('grid_panic_active')},{name:'panic',value:'2',title:_('grid_panic_inactive')},
                                	             {name:'presence',value:'present',title:_('grid_presence_present')},{name:'presence',value:'absent',title:_('grid_presence_absent')},
                                	             {name:'fire',value:'1',title:_('grid_fire_active')},{name:'fire',value:'2',title:_('grid_fire_inactive')},
                                	             {name:'hail',value:'1',title:_('grid_hail_active')},{name:'hail',value:'2',title:_('grid_hail_inactive')},
                                	             {name:'wind',value:'1',title:_('grid_wind_active')},{name:'wind',value:'2',title:_('grid_wind_inactive')},
                                	             {name:'rain',value:'1',title:_('grid_rain_active')},{name:'rain',value:'2',title:_('grid_rain_inactive')},
                                	             {name:'alarm',value:'1',title:_('grid_alarm_active')},{name:'alarm',value:'2',title:_('grid_alarm_inactive')},
                                	             {name:'alarm2',value:'1',title:_('grid_alarm2_active')},{name:'alarm2',value:'2',title:_('grid_alarm2_inactive')},
                                	             {name:'alarm3',value:'1',title:_('grid_alarm3_active')},{name:'alarm3',value:'2',title:_('grid_alarm3_inactive')},
                                	             {name:'alarm4',value:'1',title:_('grid_alarm4_active')},{name:'alarm4',value:'2',title:_('grid_alarm4_inactive')},
                                	             {name:'holiday', value:'on',title:_('grid_holiday_on')},{name:'holiday', value:'off',title:_('grid_holiday_off')}]}
                            }],
                            buttonText : {
                                newButton : _('New event'),
                                editButton : _('Edit event'),
                                enableButton : _('Enable event'),
                                disableButton : _('Disable event'),
                                testButton : _('Test event'),
                                deleteButton : _('Delete event')
                            },
                            defaultNewEntryValues: {
                            	conditions:{systemState:[{name:'holiday',value:'on'}]}
                            },
                            editorConfig : {
                                title : _('Action'),
                                staticControls : [ {
                                    type : 'text',
                                    label : _('Name'),
                                    id : 'name'
                                }, {
                                    type : 'hidden',
                                    label : 'id',
                                    id : 'id'
                                } ],
                                tabControls : [
                                        {
                                            tabLabel : _('time of execution'),
                                            tabDescription : _('Choose the time, when the activities should be executed.'),
                                            content : [ {
                                                label : _('Time'),
                                                type : 'timeReference',
                                                id : 'time',
                                                randomize: 1800,
                                                additionalAbsoluteValues:[{id:'beforeHoliday',label:_('when simulation starts')},
                                                                          {id:'afterHoliday',label:_('when simulation ends')}],
                                                referenceChangeListener:function (editor,control,selectedItem) {
                                                    if (selectedItem=='beforeHoliday')
                                                        editor.enableControl('recurrence',false);
                                                    else if (selectedItem=='afterHoliday')
                                                        editor.enableControl('recurrence',false);
                                                    else
                                                        editor.enableControl('recurrence',true);
                                                        
                                                }
                                            }, {
                                                type : 'weekdaySelection',
                                                id : 'recurrence',
                                                label : _('Recurrence'),
                                                flex : true
                                            } ]
                                        },
                                        {
                                            tabLabel : _('Activity'),
                                            tabDescription : _('Choose the activities, which should be executed.'),
                                            content : [ {
                                                type : 'ActionConfigurator',
                                                id : 'actions',
                                                flex : true,
                                                withDelay : true
                                            } ]
                                        } , {
                                            tabLabel : _('Conditions'),
                                            tabDescription : _('Choose the conditions.'),
                                            content : [{
                                                type : 'ConditionConfigurator',
                                                id : 'conditions',
                                                conditions:[
                                                            {type:'singleItem',title:_('state_daynight'),entry:[
                                                                  {type:'state',name:'daylight',value:true,title:Ext.String.format2(_('daynight_bright'),{
                    		                                            	duskTime:dss.staticDataModel.getDusk(),
                    		                                            	dawnTime:dss.staticDataModel.getDawn()
                    		                                            }),gridText:Ext.String.format2(_('grid_daynight_twilight_true'),{
                    		                                            	duskTime:dss.staticDataModel.getDusk(),
                    		                                            	dawnTime:dss.staticDataModel.getDawn()
                    		                                            })},
                                                                  {type:'state',name:'daylight',value:false,title:Ext.String.format2(_('daynight_dark'),{
                    	                                            	duskTime:dss.staticDataModel.getDusk(),
                    	                                            	dawnTime:dss.staticDataModel.getDawn()
                    	                                            }),gridText:Ext.String.format2(_('grid_daynight_twilight_false'),{
                    	                                            	duskTime:dss.staticDataModel.getDusk(),
                    	                                            	dawnTime:dss.staticDataModel.getDawn()
                    	                                            })},
                                                                  {type:'state',name:'daynight',value:true,title:Ext.String.format2(_('daynight_day'),{
                    	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
                    	                                            	sunsetTime:dss.staticDataModel.getSunset()
                    	                                            }),gridText:Ext.String.format2(_('grid_daynight_daynight_true'),{
                    	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
                    	                                            	sunsetTime:dss.staticDataModel.getSunset()
                    	                                            })},
                                                                  {type:'state',name:'daynight',value:false,title:Ext.String.format2(_('daynight_night'),{
                    	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
                    	                                            	sunsetTime:dss.staticDataModel.getSunset()
                    	                                            }),gridText:Ext.String.format2(_('grid_daynight_daynight_false'),{
                    	                                              	sunriseTime:dss.staticDataModel.getSunrise(),
                    	                                            	sunsetTime:dss.staticDataModel.getSunset()
                    	                                            })},
                    	                                            
                    	                                            ]},
                                                            {type:'timeframe',title:_('Timeframe')},
                                                            {type:'deviceState',title:_('automatic devices')},
                                                            {type:'singleItem',title:_('state_presence'),entry: [
                                                                   {type:'state',name:'presence',value:'present',title:_('presence_present'),gridText:_('grid_presence_present')},
                                                                   {type:'state',name:'presence',value:'absent',title:_('presence_absent'),gridText:_('grid_presence_absent')}]},                                               
                    	                                   {type:'multiItem',title:_('weather trigger'),entry: [
	                	                                            {type:'state',name:'rain',value:'1',title:_('rain active'),gridText:_('grid_rain_active'),group:1},
	                	                                            {type:'state',name:'rain',value:'2',title:_('rain inactive'),gridText:_('grid_rain_inactive'),group:1},
	                	                                            {type:'state',name:'wind',value:'1',title:_('wind active'),gridText:_('grid_wind_active'),group:2},
	                	                                            {type:'state',name:'wind',value:'2',title:_('wind inactive'),gridText:_('grid_wind_inactive'),group:2},
	                	                                            {type:'state',name:'hail',value:'1',title:_('hail active'),gridText:_('grid_hail_active'),group:3},
	                	                                            {type:'state',name:'hail',value:'2',title:_('hail inactive'),gridText:_('grid_hail_inactive'),group:3}]},
	                	                                   {type:'multiItem',title:_('Security'),entry: [
	                	                                           {type:'state',name:'fire',value:'1',title:_('fire active'),gridText:_('grid_fire_active'),group:1},
	                	                                           {type:'state',name:'fire',value:'2',title:_('fire inactive'),gridText:_('grid_fire_inactive'),group:1},
	                	                                            {type:'state',name:'panic',value:'1',title:_('panic_active'),gridText:_('grid_panic_active'),group:2},
	                	                                            {type:'state',name:'panic',value:'2',title:_('panic_inactive'),gridText:_('grid_panic_inactive'),group:2},
	                	                                            {type:'state',name:'alarm',value:'1',title:_('alarm_active'),gridText:_('grid_alarm_active'),group:3},
	                	                                            {type:'state',name:'alarm',value:'2',title:_('alarm_inactive'),gridText:_('grid_alarm_inactive'),group:3},
	                	                                            {type:'state',name:'alarm2',value:'1',title:_('alarm2_active'),gridText:_('grid_alarm2_active'),group:4},
	                	                                            {type:'state',name:'alarm2',value:'2',title:_('alarm2_inactive'),gridText:_('grid_alarm2_inactive'),group:4},
	                	                                            {type:'state',name:'alarm3',value:'1',title:_('alarm3_active'),gridText:_('grid_alarm3_active'),group:5},
	                	                                            {type:'state',name:'alarm3',value:'2',title:_('alarm3_inactive'),gridText:_('grid_alarm3_inactive'),group:5},
	                	                                            {type:'state',name:'alarm4',value:'1',title:_('alarm4_active'),gridText:_('grid_alarm4_active'),group:6},
	                	                                            {type:'state',name:'alarm4',value:'2',title:_('alarm4_inactive'),gridText:_('grid_alarm4_inactive'),group:6}]},
                                                            {type:'zonestate',title:_('ZoneState')}
                                                ],
                                                flex : true
                                            }]
                                        }]
                            },
                            listeners : {
                                'loadDataStore' : function(grid) {
                                    me.loadActionParameter(grid);
                                },
                                'saveEntry' : function(grid, values) {
                                    if (values.time!=null) {
                                        if (values.time.timeBase!=null) {
                                            if (values.time.timeBase=='beforeHoliday')
                                            	values.time.propertyReference="/scripts/system-addon-presence-simulator/values/holiday/*/von";
                                            if (values.time.timeBase=='afterHoliday')
                                            	values.time.propertyReference="/scripts/system-addon-presence-simulator/values/holiday/*/bis";
                                        }
                                    }
                                	values.scope="system-addon-presence-simulator";
                                    dss.raiseEvent('system-addon-timed-events.config', {
                                        actions : 'save',
                                        value : Ext.JSON.encode(values)
                                    });
                                    me.waitAndReloadTE(grid);
                                },
                                'enableEntry' : function(grid, entry) {
                                	var idVal;
                                	if (entry.get!=null) {
                                		idVal=entry.get('id');
                                	} else {
                                		idVal=[];
                                		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                                			if (entry[iIndex]!=null)
                                				idVal.push(entry[iIndex].get('id'));
                                	}
                                	
                                    dss.raiseEvent('system-addon-timed-events.config', {
                                        actions : 'enable',
                                        id :  Ext.JSON.encode(idVal)
                                    });
                                    me.waitAndReloadTE(grid);
                                },
                                'disableEntry' : function(grid, entry) {
                                	var idVal;
                                	if (entry.get!=null) {
                                		idVal=entry.get('id');
                                	} else {
                                		idVal=[];
                                		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                                			if (entry[iIndex]!=null)
                                				idVal.push(entry[iIndex].get('id'));
                                	}
                                	
                                    dss.raiseEvent('system-addon-timed-events.config', {
                                        actions : 'disable',
                                        id :  Ext.JSON.encode(idVal)
                                    });
                                    me.waitAndReloadTE(grid);
                                },
                                'deleteEntry' : function(grid, entry) {
                                	var idVal;
                                	if (entry.get!=null) {
                                		idVal=entry.get('id');
                                	} else {
                                		idVal=[];
                                		for (var iIndex=0;iIndex<entry.length;iIndex++) 
                                			if (entry[iIndex]!=null)
                                				idVal.push(entry[iIndex].get('id'));
                                	}
                                	
                                    dss.raiseEvent('system-addon-timed-events.config', {
                                        actions : 'delete',
                                        id :  Ext.JSON.encode(idVal)
                                    });
                                    me.waitAndReloadTE(grid);
                                },
                                'testEntry' : function(grid, entry) {
                                    dss.ajaxAssyncRequestWithoutAnswer("/json/event/raise", {
                                        name : 'action_execute',
                                        parameter : "path=/scripts/system-addon-timed-events/entries/" + entry.get('id')  + ";ignoreConditions=ignoreConditions"
                                    });
                                }
                            }
                        };
                        
                        var statePanel=this.makeStatePanel();                        
                        var autoModePanel=this.makeAutoModePanel();
                        var emailPanel=this.makeEmailPanel();
                        
                        var oGeneralPanel = Ext.create(
                                        'Ext.panel.Panel',
                                        {
                                            title : _('general'),
                                            style: {padding:'10px'},  
                                            autoScroll : true,
                                            items : [
                                                    {
                                                        xtype : 'fieldset',
                                                        style: {padding:'10px'},
                                                        title : _('Settings'),
                                                        autoScroll : true,
                                                        items:[statePanel,autoModePanel,emailPanel]
                                                    },
                                                    {
                                                        xtype : 'fieldset',
                                                        title : _('Hints'),
                                                        style: {padding:'10px',
                                                            color:"#005138"},
                                                        autoScroll : true,
                                                        items : [ {
                                                            xtype : 'panel',
                                                            border : 0,
                                                            style: {color:"#005138"},
                                                            html : dss.ajaxSyncRequest('locale/' + dss.staticDataModel.activeLanguage + '/hint.html',{})
                                                        } ]
                                                    } ]
                                        });

                        if (getParameterByName('mode')=='expert') {
                        	oConfigActivity.grouperField='grouping';
                        }

                        
                        var oHolidayPanel = Ext.create('DSS.gridPanel', oConfigHoliday);
                        var oActivityPanel = Ext.create('DSS.gridPanel', oConfigActivity);
                        
                        if (getParameterByName('mode')=='expert') {
                            this.fExpertMode=true;
                        }
                        
                        return Ext.create('Ext.tab.Panel', {
                            layout : 'fit',
                            cls:'generalTab',
                            items : [ oGeneralPanel, 
                                      Ext.create('Ext.panel.Panel', { title : _('holiday'), layout : 'fit', items : [ oHolidayPanel ] }) ,
                                      Ext.create('Ext.panel.Panel', {
                                layout : 'fit',
                                title : _('activity'),
                                items : [ oActivityPanel ]
                            }) ]
                        });
                    },
                    waitAndReloadTE : function(grid) {
                    	grid.setStatus(_('Saving ...'));
                    	grid.setDisabled(true);
                        var me = this;
                        var iSubscriptID = Math.floor(Math.random() * 100000000000);
                        dss.ajaxSyncRequest('/json/event/subscribe', {
                            subscriptionID : iSubscriptID,
                            name : 'system-addon-timed-events.saved'
                        });
                        dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
                            subscriptionID : iSubscriptID,
                            timeout : 60 * 1000
                        }, function() {
                            me.loadActionParameter(grid);
                            dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                                subscriptionID : iSubscriptID,
                                name : 'system-addon-timed-events.saved'
                            });
                        });
                    },
                    waitAndReloadHoliday : function(grid) {
                    	grid.setStatus(_('Saving ...'));
                    	grid.setDisabled(true);
                        var me = this;
                        var iSubscriptID = Math.floor(Math.random() * 100000000000);
                        dss.ajaxSyncRequest('/json/event/subscribe', {
                            subscriptionID : iSubscriptID,
                            name : 'system-addon-presence-simulator.saved'
                        });
                        dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
                            subscriptionID : iSubscriptID,
                            timeout : 60 * 1000
                        }, function() {
                            me.loadHolidayParameter(grid);
                            dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
                                subscriptionID : iSubscriptID,
                                name : 'system-addon-presence-simulator.saved'
                            });
                        });
                    },
                    loadGeneralParameter : function () {                    	
                        fLoading=true;
                        var sString = dss.ajaxSyncRequest('/json/property/query', {
                            'query' : '/scripts/system-addon-presence-simulator/general(*)'
                        });
                        var oResult=JSON.parse(sString);
                        if (oResult.result!=null)
                            if (oResult.result.general!=null)
                                if (oResult.result.general[0]!=null) {
                                    if (oResult.result.general[0].autoMode!=null)
                                        this.autoMode.setValue({autoMode:oResult.result.general[0].autoMode});
                                    if (oResult.result.general[0].emailMode!=null) {
                                        if (oResult.result.general[0].emailMode!=1)
                                            this.autoMode.setValue({edit_emailReceiver_email_enabler:0});
                                        else
                                            this.autoMode.setValue({edit_emailReceiver_email_enabler:1});
                                    }                                        
                                    if (oResult.result.general[0].emailReceiver!=null)
                                        this.emailAdress.setValue(oResult.result.general[0].emailReceiver);
                                }                        
                        fLoading=false;
                    },
                    loadActionParameter : function(grid) {
                    	grid.setStatus(_('Loading ...'));
                    	grid.setDisabled(true);
                        var sString = dss.ajaxSyncRequest('/json/property/query', {
                            'query' : '/scripts/system-addon-timed-events/entries/*(*)/*(*)/*(*)/*(*)'
                        });
                        var result = Ext.JSON.decode(sString);
                        oTimedEvent=dss.parsePropertyQueryAnswer(result,[{name:'name',type:'simple'},
                                                                             {name:'id',type:'simple'},
                                                                             {name:'random',type:'simple'},
                                                                             {name:'disabled',type:'condition/enabled'},
                                                                             {name:'holiday',type:'condition/state'}, // state holiday .... must be "active"
                                                                             {name:'actions',type:'action'},
                                                                             {name:'time',type:'time'},  
                                                                             {name: 'conditions', type: 'condition'},
                                                                             {name:'recurrence',type:'recurrence'}]);
                        
                        if (oTimedEvent!=null) {
                            var oResultObject=[];
                            for (var iIndex=0;iIndex<oTimedEvent.length;iIndex++){ 
                                if (oTimedEvent[iIndex].random!=null)
                                    oTimedEvent[iIndex].randomEnabled=true;
                                else
                                    oTimedEvent[iIndex].randomEnabled=false;
                                if (this.fExpertMode) {
                                	oTimedEvent[iIndex].grouping=unescape(oTimedEvent[iIndex].name).split(' ')[0];
                                	oResultObject.push(oTimedEvent[iIndex]);
                                } else {
	                                if (oTimedEvent[iIndex]['holiday']!=null)
	                                    if (oTimedEvent[iIndex]['holiday']=='on') 
	                                        oResultObject.push(oTimedEvent[iIndex]);
                                }
                            }
                            grid.loadParameter(oResultObject);
                        }
                        this.loadGeneralParameter();
                        grid.setStatus(_('Ready'));
                        grid.setDisabled(false);
                    },
                    loadHolidayParameter : function(grid) {
                    	grid.setStatus(_('Loading ...'));
                    	grid.setDisabled(true);
                        var sString = dss.ajaxSyncRequest('/json/property/query', {
                            'query' : '/scripts/system-addon-presence-simulator/values/holiday/*(*)'
                        });
                        var result = Ext.JSON.decode(sString);
                        var oResultObject = dss.parsePropertyQueryAnswer(result, [ {
                            name : 'name',
                            type : 'simple'
                        }, {
                            name : 'id',
                            type : 'simple'
                        }, {
                            name : 'von',
                            type : 'date'
                        }, {
                            name : 'bis',
                            type : 'date'
                        } ]);
                        if (oResultObject != null) {
                            grid.loadParameter(oResultObject);
                        }
                        this.loadGeneralParameter();
                        grid.setStatus(_('Ready'));
                        grid.setDisabled(false);
                    }
                    
                });

Ext.onReady(function() {
    dss.buildUpLang(['locale/{languageSuffix}/presence-simulator.po']);
    var presencesim = Ext.create('DSS.addon.PresenceSimulator');
    presencesim.initPage();
});
